; TIP1162.LSP: BRACKET.LSP   Draw Brackets   (c)1995, Huang Hua Chang

;  This program creates multiple brackets with cutouts and with 
;  or without flanges in ship design or in structural design.

(defun C:BRACKET ()
  (setq PLINEW0 (getvar "PLINEWID"))
  (setvar "PLINEWID" 0)
  (initget 7) 
  (setq LA (getreal "\nlength of edge A = la: "))
  (initget 6) 
  (setq LB (getreal "\nlength of edge B<=la>: "))
  (if (= LB nil) (setq LB LA)) 
  (initget 5) 
  (setq DA (getreal "\nroot length of edge A = da: "))
  (initget 4) 
  (setq DB (getreal "\nroot length of edge b<=da>: "))
  (if (= DB nil) (setq DB DA)) 
  (setq OBA (entsel "\nPick the relatively HOR boundary line : "))
  (setq NMOBA (ENTGET (car OBA)))
  (setq PT11 (list (cadr (assoc 10 NMOBA)) (caddr (assoc 10 NMOBA))))
  (setq PT12 (list (cadr (assoc 11 NMOBA)) (caddr (assoc 11 NMOBA))))
  (setq OBB (entsel "\nPick the relatively VER boundary line : "))
  (setq NMOBB (ENTGET (car OBB)))
  (setq PT21 (list (cadr (assoc 10 NMOBB)) (caddr (assoc 10 NMOBB))))
  (setq PT22 (list (cadr (assoc 11 NMOBB)) (caddr (assoc 11 NMOBB))))
  (setq PT0 (inters PT11 PT12 PT21 PT22))
  (princ "pt0=")
  (princ PT0)
  (setq XOBA (car (cadr OBA)))
  (if (> XOBA (car PT0)) 
    (progn
      (setq ADB 0)
      (if (> (car PT12) (car PT11)) 
        (progn
          (setq PTA1 PT11)
          (setq PTA2 PT12)
        )
        (progn
          (setq PTA1 PT12)
          (setq PTA2 PT11)
      ))
    )
  )
  (if (< XOBA (car PT0)) 
    (progn
      (setq ADB pi)
      (if (< (car PT12) (car PT11)) 
        (progn
          (setq PTA1 PT11)
          (setq PTA2 PT12)
        )
        (progn
          (setq PTA1 PT12)
          (setq PTA2 PT11)
      ))
    )
  )
  (setq YOBB (car (cdr (cadr OBB))))
  (if (> YOBB (cadr PT0)) 
    (progn 
      (setq ADA (/ pi 2))
      (if (> (cadr PT22) (cadr PT21)) (setq PTB1 PT21 PTB2 PT22)
      (setq PTB1 PT22 PTB2 PT21))
    )
  )
  (if (< YOBB (cadr pt0)) 
    (progn 
      (setq ADA (* pi 1.5))
      (if (< (cadr PT22) (cadr PT21)) (setq PTB1 PT21 PTB2 PT22)
      (setq PTB1 PT22 PTB2 PT21))
    )
  )
  (if (and (> XOBA (car pt0)) (< YOBB (cadr pt0))) 
    (setq PHASE 24)
  )
  (if (and (< XOBA (car pt0)) (> YOBB (cadr pt0))) 
    (setq PHASE 24)
  )
  (if (and (> XOBA (car pt0)) (> YOBB (cadr pt0))) 
    (setq PHASE 13)
  )
  (if (and (< XOBA (car pt0)) (< YOBB (cadr pt0))) 
    (setq PHASE 13)
  )
  (setq ANGA (angle PTA1 PTA2))
  (setq ANGB (angle PTB1 PTB2))
  (setq PTAM (polar PT0 anga LA))
  (setq PTBN (polar PT0 angb LB))
  (princ "ptam=")
  (princ PTAM)
  (princ "ptbn=")
  (princ PTBN)
  (initget "Yes No") 
  (setq FL (getkword "\nis there a flate plate or a flange(y/n)?<n>"))
  (cond ((= FL nil) (setq FL "No")) 
    ((= FL "Yes") 
      (progn 
        (setq DT (* la 0.035))
      )
    )
  )
  (setq PTM (polar PTAM ADA DA))
  (setq PTN (polar PTBN ADB DB))
  (setq PTMMN (list (/ (+ (car PTM) (car PTN)) 2) 
  (/ (+ (cadr PTM) (cadr PTN)) 2)))
  (initget 1) 
  (setq CO (getreal "\nsize of cutout,
      Input <+>value for cutout arc radius,
      Input <->value for cutout triangular edge:\n "))
      (setq PTA (polar PT0 ANGA (abs CO)))
      (setq PTB (polar PT0 ANGB (abs CO)))
      (setq ACO (abs CO))
      (if (= fl "Yes") (progn
          (setq ANGMN (angle PTM PTN))
          (if (= PHASE 13) (setq ANGMM (- ANGMN (/ pi 2))))
          (if (= PHASE 24) (setq ANGMM (+ ANGMN (/ pi 2))))
          (setq PTMM (polar PTM ANGMM DT))
          (setq PTNN (polar PTN ANGMM DT))
          (princ "ptmm=")
          (princ PTMM)
          (princ "ptnn=")
          (princ PTNN)
          (command "pline" PTM PTMM PTNN PTN "")
        )
      )
      (cond ((< CO 0) (command "pline" PTA PTAM PTM PTN PTBN PTB "c"))
        ((> CO 0) 
          (progn
            (if (= PHASE 24) 
              (command "pline" PTA PTAM PTM PTN PTBN PTB "arc" "r" ACO PTA "")
            ) 
            (if (= PHASE 13)  
              (command "pline" PTB PTBN PTN PTM PTAM PTA "arc" "r" ACO PTB "")
            )
          ) 
        )
      ) 
      (command "copy" PTMMN "c" PTM PTMM "" "m" PT0)
      (setvar "PLINEWID" PLINEW0)
); end bracket.lsp

