; TIP1163.LSP: BLKALTER.LSP   Alter Blocks   (c)1995, Stefan Predoiu

(defun sterr (STR)
  (if (/= "Function cancelled") 
  (prompt (strcat "**> Error : " STR)))
  (command "ucs" "previous")
  (setq *error* OERR)
  (setvar "CMDECHO" 1)
  (princ)
) ;sterr
;----------------------------------------------------------
(defun modifica () ; Adds and deletes entities from the 
  ; block
  (princ (strcat 
      "\n**> Select entities to be ADDED to the block "
  (strcase NUMEBL) " <None> :\n")) 
  (setq ADAUGA (ssget))
  (if ADAUGA (command ADAUGA))
  (command "r")
  (princ (strcat 
      "\n**> Select entities to be DELETED from the block "
  (strcase NUMEBL) " (One at the time) <None> :\n"))
  (setq STERGE (entsel))
  (while STERGE
    (command (car STERGE))
    (setq STERGE (entsel))
  ) ;while
  (command "")
) ;modifica
;----------------------------------------------------------
(defun alege ( / NRORD T) ; Choose the block name in the
  ; blocks' list
  (textpage)
  (princ "\n**> Names of exploded blocks: ")
  (setq NRORD 1)
  (setq T J)
  (repeat j
    (princ (strcat "\n  - " (nth (- T NRORD) LISTNB)))
    (setq NRORD (1+ NRORD))
  ) ;repeat
  (setq NUMEBL (strcase 
  (getstring "\n**> Name of the block to redo: ")))
  (while (not (member NUMEBL LISTNB))
    (setq NUMEBL (strcase 
    (getstring "\n**> Name of the block to redo: ")))
  ) ;while
) ;alege 
;----------------------------------------------------------
(defun aflapoz () ; Finds the block's position in the
  ; blocks' list
  (setq LOC 0)
  (while (/= (nth LOC LISTNB) NUMEBL)
    (setq LOC (1+ LOC))
  ) ;while
  (setq SELENTBL (nth LOC LISTSEB)
    pctins (nth LOC LISTPCTI)
  ) ;setq
) ;aflapoz
;----------------------------------------------------------
(defun redulist (LISTA / I ELEMLIST NOULIST) ; Changes the
  ; blocks' list after redefining one of them
  (setq I 0 NOULIST nil)
  (while (setq ELEMLIST (nth I LISTA))
    (if (/= I LOC)
      (setq NOULIST (cons ELEMLIST NOULIST))
    ) ;if
    (setq I (1+ I))
  ) ;while
  (setq LISTA NOULIST)
) ;redulist
;----------------------------------------------------------
(defun c:redoblock ( / NUMEBL SELENTBL PCTINS ADAUGA 
    STERGE LOC )
  ;;; Redefines the previously exploded blocks

  (setvar "CMDECHO" 0)
  (setq OERR *error*
    *error* STERR
  ) ;setq
  (setvar "HIGHLIGHT" 1)
  (if LISTNB
    (progn
      (command "ucs" "world")
      (alege)
      (aflapoz)
      (command "block" NUMEBL "Y" PCTINS SELENTBL)
      (modifica)
      (command "insert" NUMEBL PCTINS 1 1 0)
      (setq LISTSEB (redulist LISTSEB)
        LISTNB (redulist LISTNB)
        J (length LISTNB)
        LISTPCTI (redulist LISTPCTI)
      ) ;setq
      (command "ucs" "previous")
    ) ;progn
    (princ "\n**> No exploded blocks found!")
  ) ;if
  (setq *error* OERR)
  (setvar "cmdecho" 1)
  (princ)
) ;redoblock
;----------------------------------------------------------
(defun C:BLOCKALTER ( / CONTINUA CEESEL BL TIPENT ENTBL 
    ULTIMAENT UE) 
  ;;; Explodes blocks by keeping in memory their
  ;;; entities for a future redefinition

  (setvar "cmdecho" 0)
  (setq OERR *error*
    *error* STERR
  ) ;setq
  (command "ucs" "world")
  (setq CONTINUA 1)
  (while CONTINUA 
    (setq CEESEL (entsel "\n**> Select the block: "))
    (if CEESEL 
      (progn
        (setq BL (entget (car CEESEL))
          TIPENT (cdr (assoc 0 bl))
        ) ;setq
        (if (= tipent "INSERT")
          (progn
            (setq NUMEBL (cdr (assoc 2 BL)))
            (if (or (assoc 66 BL)
              (= (substr NUMEBL 1 1) "*"))
              (princ (strcat 
                  "    This is either a HATCH or a block with ATTRIBUTES."
              " Try again !"))
              (if (member NUMEBL LISTNB)
                (princ (strcat "    The block " NUMEBL
                " has already been exploded."))
                (setq CONTINUA nil)
              ) ;if
            ) ;if
          ) ;progn
          (princ (strcat "    This is a " TIPENT 
          ", not a BLOCK !"))
        ) ;if
      ) ;progn
      (princ "    You must select a block !")
    ) ;if
  ) ;while
  (setq ENTBL (cdr (assoc -1 BL))
    ULTIMAENT (entlast)
    PCTINS (cdr (assoc 10 BL))
  ) ;setq
  (setq LISTNB (cons NUMEBL LISTNB) 
    LISTPCTI (cons PCTINS LISTPCTI)
    J (length LISTNB)
  ) ;setq
  (command "explode" ENTBL)
  (setq SELENTBL (ssadd) UE (entnext ULTIMAENT) I 1)
  (princ (strcat "\n**> One dot / " NUMEBL 
  " block's entity: ")) 
  (while UE
    (if (= (FIX (/ I 25.)) (/ I 25.))
      (princ I)
      (princ ".")
    ) ;if
    (setq SELENTBL (ssadd UE SELENTBL)
      UE (entnext UE)
      I (1+ I)
    ) ;setq
  ) ;while
  (princ (strcat "  => " (itoa (1- I)) " entities"))
  (setq LISTSEB (cons SELENTBL LISTSEB))
  (command "ucs" "previous")
  (princ (strcat "\n**> Don't forget to run Redoblock"
  " after altering the block !"))
  (setq *error* OERR)
  (setvar "CMDECHO" 1)
  (princ)
) ;end blockalter.lsp
