; TIP1164.LSP: DDXREF.LSP   Dialog Box for Xrefing   (c)1995, Michael Belmont

;External reference dialog box 
(defun dxf (CODE ELIST)
  (cdr (assoc CODE ELIST))
)

(defun action_off ()
  (mode_tile "BND" 1)
  (mode_tile "DTC" 1)
  (mode_tile "PTH" 1)
  (mode_tile "RLD" 1)
)

(defun action_on ()
  (mode_tile "BND" 0)
  (mode_tile "DTC" 0)
  (mode_tile "PTH" 0)
  (mode_tile "RLD" 0)
)

(defun chg_path ()
  (if (not (new_dialog "path" dcl_id))(exit))
  (setq XSEL (nth (atoi XSEL) XLIST))
  (setq FLAG t)
  (while (setq XTEMP (tblnext "block" FLAG))
    (if (= XSEL (dxf 2 XTEMP))
      (setq XPATH (dxf 1 XTEMP))
    )
    (setq FLAG nil)
  )
  (set_tile "cpath" XPATH)
  (action_tile "npath" "(type_path)")
  (action_tile "get_npath" "(get_path)")
  (start_dialog)
)

(defun type_path ()
  (setq NPATH (strcat (strcase $value) ".DWG"))
  (if (/= NPATH ".DWG")
    (progn  
      (if (findfile NPATH)
        (setq KEY "PTH")
        (alert "File not Found")
      )
    )
  )
)

(defun get_path ()
  (setq NPATH (getfiled "Xref Paths" "" "dwg" 2))
  (if (not NPATH)(setq NPATH "")(setq KEY "PTH"))
  (set_tile "npath" NPATH)
)

(defun chk_block ()
  (setq XREFNAME "")
  (setq CHKFILE (substr files 1 (- (strlen files) 4)))
  (setq N (strlen chkfile))
  (while (and (/= 0 N)(not (= "\\" (substr CHKFILE N 1))))
    (setq XREFNAME (strcat XREFNAME (substr CHKFILE N 1)))
    (setq N (- N 1))
  )
  (setq XNAME "")
  (setq N (strlen XREFNAME))
  (while (and (/= 0 N)(substr XREFNAME N 1))
    (setq XNAME (strcat XNAME (substr XREFNAME N 1)))
    (setq N (- N 1))
  )
  (setq FLAG t)
  (while (setq XTEMP (tblnext "block" FLAG))
    (if (= XNAME (dxf 2 XTEMP))
      (progn
        (setq KEY "")
        (setq FILES "")
        (mode_tile "xfiles" 0)
        (if (dxf 1 XTEMP)
          (alert (strcat "Xref " XNAME " has already been loaded."
          "\nUse reload to update its definition")) 
          (alert (strcat XNAME 
        " is already a standard block in the current drawing")))
      )
    )
    (setq FLAG nil)
  )
)

(defun get_file ()
  (setq KEY "ATC")
  (action_off)
  (mode_tile "xfiles" 1)
  (mode_tile "actions" 1)
  (setq FILES (getfiled "Xrefs" "" "dwg" 2))
  (setq XLIST (append XLIST (list FILES)))
  (if (/= FILES nil) (progn (chk_block)(set_tile "file" FILES))
  (progn (setq KEY "")(mode_tile "xfiles" 0)))
)

(defun test_file ()
  (action_off)
  (if (not FILES) 
    (setq KEY "")
  (setq KEY "ATC"))
  (setq FILES (strcat (strcase $value) ".DWG"))
  (if (and (/= FILES ".DWG") (not (findfile FILES)))
    (progn 
      (alert "File not Found")
    (set_tile "file" ""))
    (chk_block)  
  )
)     

(defun do_xsel ()
  (action_on)
  (setq XSEL (get_tile "xfiles")) 
  (setq SLST '())      
  (setq CT 1)
  (setq PCARD "")
  (setq XSEL (strcat xsel " "))  
  (while (/= CT (1+ (strlen XSEL)))
    (if (/= (substr XSEL CT 1) " ")
      (setq PCARD (strcat PCARD (substr XSEL CT 1)))
      (progn                                          
        (setq STRL (strlen (nth (atoi PCARD) XLIST)))
        (setq SLST (cons (nth (atoi PCARD) XLIST) SLST))
      (setq PCARD ""))
    )
    (setq CT (1+ CT))
  )                                                
  (setq LEN (length SLST))
  (setq XCMDLST "")
  (setq CNT 0)
  (while (< CNT LEN)
    (setq XCMDLST (strcat XCMDLST (nth CNT SLST) ","))
    (setq CNT (1+ CNT))
  )
)

(defun get_xrefs ()
  (setq XLIST '())
  (setq XTEMP (tblnext "block" t))
  (while XTEMP
    (if (dxf 1 XTEMP)
      (setq XLIST (append XLIST (list (dxf 2 XTEMP))))
    )
    (setq XTEMP (tblnext "block"))
  )
)

(defun C:DDXREF (/ KEY FILES DCL_ID XSEL XPATH NPATH)
  (get_xrefs)
  (if (< (setq DCL_ID (load_dialog "ddxref.dcl"))0)(exit))
  (setq WHAT_NEXT 5)
  (get_xrefs)
  (while (< 2 WHAT_NEXT)
    (if (not (new_dialog "ddxref" DCL_ID))(exit))
    (start_list "xfiles")
    (mapcar 'add_list xlist)
    (end_list)
    (action_tile "atc" "(get_file)")
    (action_tile "file" "(test_file)")
    (action_tile "BND" "(setq key $key)")
    (action_tile "xfiles" "(do_Xsel)")
    (action_tile "DTC" "(setq key $key)")
    (action_tile "PTH" "(chg_path)")
    (action_tile "RLD" "(setq key $key)")
    (action_tile "cancel" "(setq key \"\")")
    (setq what_next (start_dialog))
  )
  (cond 
    ((= key "ATC")(command "_.XREF" "A" files))
    ((= key "BND")(command "_.XREF" "B" xcmdlst))
    ((= key "DTC")(command "_.XREF" "D" xcmdlst))
    ((= key "RLD")(command "_.XREF" "R" xcmdlst))
    ((= key "PTH")(command "_.XREF" "P" xsel npath))
    ((= key "")) 
    (nil)
  )
  (princ)
); end ddxref.lsp
