; TIP1168.LSP: MAKEGRID.LSP   Make Grids   (c)1995, Howard M. fulmer

;--- VARIABLE   DESCRIPTION
;--- ========   ===========
;---   LEN       X size of virtual screen
;---   ICOL      Current column number
;---   IROW      Current row number
;---   NCOL      Number of grid columns
;---   NROW      Number of grid rows
;---   PLL       Lower-left corner of grid
;---   PLR       Lower-right corner of grid
;---   PUL       Upper-left corner of grid
;---   PUR       Upper-right corner of grid
;---   TH        Text height
;---   TP        Text insertion point
;---   TX        View name, format: IROW-ICOL
;---   WID       Y size of virtual screen
(defun C:MAKEGRID(/ LEN ICOL IROW NCOL NROW PLL
                    PLR PUL PUR TH TP TX WID
                 )
  (prompt "\nMAKEGRID (v2.0, 12/94) HMF CONSULTING (610) 275-9866")
  (prompt "\n----------------------------------------------------")
  (setq NROW (getint "\nRows: ")
        NCOL (getint "\nColumns: ")
        LEN (car (getvar "VSMAX"))
        WID (cadr (getvar "VSMAX"))
        PLL (list 0.0 0.0)
        PLR (list LEN 0.0)
        PUR (list LEN WID)
        PUL (list 0.0 WID)
        TH (/ WID 4.0)
        OB (getvar "BLIPMODE")
        OC (getvar "CMDECHO")
  )
  (setvar "BLIPMODE" 0)
  (setvar "CMDECHO" 0)
    (command ".pline" PLL PLR PUR PUL "c")
  (command ".array" "l" "" "r" NROW NCOL WID LEN)

;--- ZOOM each grid and assign VIEW name

  (setq IROW 1)
  (while (<= IROW NROW)
     (setq ICOL 1)
     (while (<= ICOL NCOL)
            (setq PLL (list (* LEN (- ICOL 1)) (* WID (- IROW 1)))
                  PUR (list (* LEN ICOL) (* WID IROW))
            )
            (command ".zoom" "w" PLL PUR)
            (setq TP (getvar "VIEWCTR")
                  TX (strcat (itoa IROW) "-" (itoa ICOL))
            )
            (command ".text" "m" TP TH "0" TX)
            (prompt (strcat "\n*** Processing cell " TX))
            (command ".view" "s" TX)
        (setq ICOL (1+ ICOL))
      )                             ;--- end column loop
      (setq IROW (1+ IROW))
  )                                 ;--- end row loop
  (setvar "blipmode" OB)
  (setvar "cmdecho" OC)
  (command ".zoom" "a")
  (prin1)
); end makegrid.lsp
